/* @C:\web_585\SQL\end_conv\oracle\4206_GOPTRGO_LOG_GOP_ITEMORCAOP.sql
   Trigger criada para gerar log das transaes na tabela ITEMORCAOP */

CREATE OR REPLACE TRIGGER LOG_GOP_ITEMORCAOP
AFTER DELETE OR UPDATE OR INSERT
ON ITEMORCAOP FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(700);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.NRANOORCAOP IS NOT NULL THEN
         V_DESC := V_DESC || ' AnoOrc=' || :OLD.NRANOORCAOP;
      END IF;

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.NRSEQITEMORCA IS NOT NULL THEN
         V_DESC := V_DESC || ' NrSeqItOrc=' || :OLD.NRSEQITEMORCA;
      END IF;
      
      IF :OLD.CDVERSORCAOP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdVersaoOrc=' || :OLD.CDVERSORCAOP;
      END IF;
      
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRANOORCAOP||';'||:OLD.CDFILIAL||';'||:OLD.NRSEQITEMORCA||';'||:OLD.CDVERSORCAOP;
   ELSE
      IF UPDATING THEN
         IF (:OLD.IDENTRSAIDOP  <> :NEW.IDENTRSAIDOP) THEN
               V_DESC := V_DESC || ' IdEntSaiOp=' ||TO_CHAR(:NEW.IDENTRSAIDOP);
         END IF;

         IF (:OLD.CDTIPOOPER   <> :NEW.CDTIPOOPER ) THEN
               V_DESC := V_DESC || ' CdTpOper=' ||TO_CHAR(:NEW.CDTIPOOPER );
         END IF;

         IF (:OLD.CDDESPADMFAT  <> :NEW.CDDESPADMFAT) THEN
               V_DESC := V_DESC || ' CdDesPadmFat=' ||:NEW.CDDESPADMFAT;
         END IF;

         IF (:OLD.CDDESPPREV  <> :NEW.CDDESPPREV) THEN
               V_DESC := V_DESC || ' CdDesPrev=' ||:NEW.CDDESPPREV;
         END IF;

         IF (:OLD.DTORCAMENTOITEM  <> :NEW.DTORCAMENTOITEM) THEN
               V_DESC := V_DESC || ' DtOrcIt=' ||:NEW.DTORCAMENTOITEM;
         END IF;

         IF (:OLD.DTMESBASEITEM  <> :NEW.DTMESBASEITEM) THEN
               V_DESC := V_DESC || ' DtMesBaseIt=' ||:NEW.DTMESBASEITEM;
         END IF;

         IF (:OLD.IDTIPOORCAOP  <> :NEW.IDTIPOORCAOP) THEN
               V_DESC := V_DESC || ' IdTpOrc=' ||:NEW.IDTIPOORCAOP;
         END IF;

         IF (:OLD.VRORCAMENTOJAN  <> :NEW.VRORCAMENTOJAN) THEN
               V_DESC := V_DESC || ' VrOrcJan=' ||:NEW.VRORCAMENTOJAN;
         END IF;

         IF (:OLD.VRORCAMENTOFEV  <> :NEW.VRORCAMENTOFEV) THEN
               V_DESC := V_DESC || ' VrOrcFev=' ||:NEW.VRORCAMENTOFEV;
         END IF;

         IF (:OLD.VRORCAMENTOMAR  <> :NEW.VRORCAMENTOMAR) THEN
               V_DESC := V_DESC || ' VrOrcMar=' ||:NEW.VRORCAMENTOMAR;
         END IF;

         IF (:OLD.VRORCAMENTOABR  <> :NEW.VRORCAMENTOABR) THEN
               V_DESC := V_DESC || ' VrOrcAbr=' ||:NEW.VRORCAMENTOABR;
         END IF;

         IF (:OLD.VRORCAMENTOMAI  <> :NEW.VRORCAMENTOMAI) THEN
               V_DESC := V_DESC || ' VrOrcMai=' ||:NEW.VRORCAMENTOMAI;
         END IF;

         IF (:OLD.VRORCAMENTOJUN  <> :NEW.VRORCAMENTOJUN) THEN
               V_DESC := V_DESC || ' VrOrcJun=' ||:NEW.VRORCAMENTOJUN;
         END IF;

         IF (:OLD.VRORCAMENTOJUL  <> :NEW.VRORCAMENTOJUL) THEN
               V_DESC := V_DESC || ' VrOrcJul=' ||:NEW.VRORCAMENTOJUL;
         END IF;

         IF (:OLD.VRORCAMENTOAGO  <> :NEW.VRORCAMENTOAGO) THEN
               V_DESC := V_DESC || ' VrOrcAgo=' ||:NEW.VRORCAMENTOAGO;
         END IF;

         IF (:OLD.VRORCAMENTOSET  <> :NEW.VRORCAMENTOSET) THEN
               V_DESC := V_DESC || ' VrOrcSet=' ||:NEW.VRORCAMENTOSET;
         END IF;

         IF (:OLD.VRORCAMENTOOUT  <> :NEW.VRORCAMENTOOUT) THEN
               V_DESC := V_DESC || ' VrOrcOut=' ||:NEW.VRORCAMENTOOUT;
         END IF;
         
         IF (:OLD.VRORCAMENTONOV  <> :NEW.VRORCAMENTONOV) THEN
               V_DESC := V_DESC || ' VrOrcNov=' ||:NEW.VRORCAMENTONOV;
         END IF;
         
         IF (:OLD.VRORCAMENTODEZ  <> :NEW.VRORCAMENTODEZ) THEN
               V_DESC := V_DESC || ' VrOrcDez=' ||:NEW.VRORCAMENTODEZ;
         END IF;
         
         IF (:OLD.IDITEMORCAMENTO  <> :NEW.IDITEMORCAMENTO) THEN
               V_DESC := V_DESC || ' IdItOrc=' ||:NEW.IDITEMORCAMENTO;
         END IF;
         
         IF (:OLD.CDSERVFILI  <> :NEW.CDSERVFILI) THEN
               V_DESC := V_DESC || ' CdServ=' ||:NEW.CDSERVFILI;
         END IF;
         
         IF (:OLD.QTORCAMENTOJAN  <> :NEW.QTORCAMENTOJAN) THEN
               V_DESC := V_DESC || ' QtOrcJan=' ||:NEW.QTORCAMENTOJAN;
         END IF;
         
         IF (:OLD.QTORCAMENTOFEV  <> :NEW.QTORCAMENTOFEV) THEN
               V_DESC := V_DESC || ' QtOrcFev=' ||:NEW.QTORCAMENTOFEV;
         END IF;
         
         IF (:OLD.QTORCAMENTOMAR  <> :NEW.QTORCAMENTOMAR) THEN
               V_DESC := V_DESC || ' QtOrcMar=' ||:NEW.QTORCAMENTOMAR;
         END IF;
         
         IF (:OLD.QTORCAMENTOABR  <> :NEW.QTORCAMENTOABR) THEN
               V_DESC := V_DESC || ' QtOrcAbr=' ||:NEW.QTORCAMENTOABR;
         END IF;         

         IF (:OLD.QTORCAMENTOMAI  <> :NEW.QTORCAMENTOMAI) THEN
               V_DESC := V_DESC || ' QtOrcMai=' ||:NEW.QTORCAMENTOMAI;
         END IF;         

         IF (:OLD.QTORCAMENTOJUN  <> :NEW.QTORCAMENTOJUN) THEN
               V_DESC := V_DESC || ' QtOrcJun=' ||:NEW.QTORCAMENTOJUN;
         END IF;         

         IF (:OLD.QTORCAMENTOJUL  <> :NEW.QTORCAMENTOJUL) THEN
               V_DESC := V_DESC || ' QtOrcJul=' ||:NEW.QTORCAMENTOJUL;
         END IF;         

         IF (:OLD.QTORCAMENTOAGO  <> :NEW.QTORCAMENTOAGO) THEN
               V_DESC := V_DESC || ' QtOrcAgo=' ||:NEW.QTORCAMENTOAGO;
         END IF;         

         IF (:OLD.QTORCAMENTOSET  <> :NEW.QTORCAMENTOSET) THEN
               V_DESC := V_DESC || ' QtOrcSet=' ||:NEW.QTORCAMENTOSET;
         END IF;         

         IF (:OLD.QTORCAMENTOOUT  <> :NEW.QTORCAMENTOOUT) THEN
               V_DESC := V_DESC || ' QtOrcOut=' ||:NEW.QTORCAMENTOOUT;
         END IF;         

         IF (:OLD.QTORCAMENTONOV  <> :NEW.QTORCAMENTONOV) THEN
               V_DESC := V_DESC || ' QtOrcNov=' ||:NEW.QTORCAMENTONOV;
         END IF;         

         IF (:OLD.QTORCAMENTODEZ  <> :NEW.QTORCAMENTODEZ) THEN
               V_DESC := V_DESC || ' QtOrcDez=' ||:NEW.QTORCAMENTODEZ;
         END IF;         

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRANOORCAOP||';'||:OLD.CDFILIAL||';'||:OLD.NRSEQITEMORCA||';'||:OLD.CDVERSORCAOP;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRANOORCAOP||';'||:NEW.CDFILIAL||';'||:NEW.NRSEQITEMORCA||';'||:NEW.CDVERSORCAOP;

         IF :NEW.NRANOORCAOP IS NOT NULL THEN
            V_DESC := V_DESC || ' AnoOrc=' || :NEW.NRANOORCAOP;
         END IF;

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || ' CdFilial=' || :NEW.CDFILIAL;
         END IF;
      
         IF :NEW.NRSEQITEMORCA IS NOT NULL THEN
            V_DESC := V_DESC || ' NrSeqItOrc=' || :NEW.NRSEQITEMORCA;
         END IF;
      
         IF :NEW.CDVERSORCAOP IS NOT NULL THEN
            V_DESC := V_DESC || ' CdVersaoOrc=' || :NEW.CDVERSORCAOP;
         END IF;

      END IF; 


   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA, DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('ITEMORCAOP',  V_DTOPER, V_USUARIO,
                V_TIPO, V_ITPESQ, V_DESC, V_DSSERVERRDM,
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD,
                V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_GOP_ITEMORCAOP','5.85.000'); END;
/
