var ger01900_cadastroproduto_controller = function (ZhUtil, ScreenService, templateManager, General, ProcProdWorkflowService, ProdutoService, ZhFilterPreferences, restEngine, MessageService) {
		
	var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey", "$error"];
	
	this.setDynamicRequiredFields = function(mainWidget) {
		General.callRestEngine('cadEst#/crud/paramgeral', 'FilterData', []).then(success => {
			if(success.dataset.paramgeral.length){
				let paramgeral = success.dataset.paramgeral[0];
				let obrigaNCM = paramgeral.IDOBRNCMCADPR == 'S'? true : false;
				let widgetFiscal = templateManager.container.getWidget('Fiscal');
				let fieldNCM = widgetFiscal.getField('CDCLASFISC');
				if(obrigaNCM)
					fieldNCM.validations = {"required": {"message": "Campo Obrigatorio"}};
            	else
                	delete fieldNCM.validations.required;
			}
		});
	};
	
	this.openFilterWidget = function(widget) {  
		
		var defaultFilter = Util.clone(widget.currentRow);
		
		defaultFilter.IDPRODATIVPR = 'S';
		
        ZhFilterPreferences.setOriginalFilter(widget.id, defaultFilter);
        ZhFilterPreferences.openFilterWidget(widget, defaultFilter);

	};
	
	this.allRulesWidgets = function() {
		this.rulesToCardapio(templateManager.container.getWidget('Cardapio'));
		this.rulesToCatering(templateManager.container.getWidget('Catering'));
		this.rulesToEstoque(templateManager.container.getWidget('Estoque'));
		this.rulesToProducao(templateManager.container.getWidget('Produção'));
	};	

	this.allWidgetsToView = function() {
		var widget = templateManager.container.getWidget('produtos2');
		widget.view();
		widget.getParent().list();
		widget.widgets.forEach(function(widget) {
			widget.view();
			widget.template = widget.templateToView;
		});
	};

    this.afterChange = function(widget) {
        var mainWidget = widget.getParent();
        mainWidget.widgets.forEach(function(widget) {
            widget.enabled = true;
        });
    	templateManager.container.getWidget('arvsprod').enabled = true;
    	templateManager.container.getWidget('vendas').enabled = true;

		widget.template = widget.templateToView;
		widget.view();
		mainWidget.view();
    };

	this.callSave = function(widget, route) {
		ScreenService.showLoader();
		var row = Util.clone(widget.currentRow, ignoredKeys);
		row.DEBUGMODE = false;
		General.callRestEngine(route, 'Row', row).then(function(result) {
			var currentProduct = result.dataset.produto[0];
			widget.currentRow = currentProduct;
			var widgetPrincipal = widget.container.getWidget('produtos');
			widgetPrincipal.currentRow = currentProduct;
			this.updateWidgets(widget.currentRow);
			this.allWidgetsToView();
			this.updateProductInMainWidget();
			this.afterChange(widget);
			ScreenService.successNotification("Produto cadastrado com sucesso");
			if(result.messages) {
				ScreenService.alertNotification(result.messages[0].message);
			}
			ScreenService.hideLoader();
		}.bind(this), this.errorRequest);
	};

    this.cancelEdit = function(widget) {
    	var __is_new = angular.copy(widget.currentRow.__is_new);

    	this.afterChange(widget);

    	widget.currentRow = widget.backupRow;

		if (__is_new) {
			ScreenService.closeSwipe();
			widget.getParent().getParent().dataSource.data.pop();
		}
	};

	this.deleteGroupTree = function(widget) {
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			General.callRestEngine('cadEst_produto#/crud/prodarvoreprod/remove', 'Row', widget.currentRow).then(function () {
				ScreenService.closeSwipe().then(function () {
					widget.activate();
					widget.reload();
				});
			}, this.errorRequest);
		}.bind(this));
	};

    this.editMode = function (widgetEditing, skipeEnabled) {
    	var nameSkip = widgetEditing.name;
		var mainWidget = widgetEditing.getParent();
		
		if (!skipeEnabled) {
    		mainWidget.widgets.forEach(function(widget) {
    			if (widget.name !== nameSkip) {
    				widget.enabled = false;
    			}
			});
		}
		
    	templateManager.container.getWidget('arvsprod').enabled = false;
    	templateManager.container.getWidget('vendas').enabled = false;
    	let rowBackup = Util.clone(widgetEditing.currentRow, ignoredKeys);
    	widgetEditing.backupRow = rowBackup;
    	widgetEditing.template = widgetEditing.templateToForm;
		mainWidget.edit();
		widgetEditing.edit();
		ScreenService.showLoader();
    	setTimeout(time =>{
    		widgetEditing.currentRow = rowBackup;
    		ScreenService.hideLoader();
    	}, 1000);
    };
    
    this.errorRequest = function(error) {
    	if (error.data.error) {
			ScreenService.showMessage(error.data.error);
		} else {
			ScreenService.showMessage(error);
		}
		ScreenService.hideLoader();
    };

    this.gerFilterForPrductComplete = function() {
    	var levels = General.getLevelByMask('GER_CDPICTPROD', 1);

    	return levels.length;
	};
	
	this.getMaskPenulLevel = function() {
		var mask = getLocalVar('GER_CDPICTPROD');
		mask = mask.split('.');
		mask.pop();
		return mask.join('.');
	};

	this.grupFieldReadOnly = function() {
		var widget = templateManager.container.getWidget('arvsprod');
		var field = widget.getField('NMARVOREPROD');
		field.readOnly = true;
	};

	this.newRelacTreeeProd = function (widget) {
		widget.newRow();
		widget.currentRow.CDPRODUTO = widget.getParent().currentRow.CDPRODUTO;
	};

	this.isProductStock = function() {
		var widget = templateManager.container.getActiveWidget();
		var indent = widget.currentRow.IDESTOCOMP;
		if (indent === 'E') {
			return true;
		} else {
			return false;
		}
	};

    this.rulesItemGenero = function(widget) {
    	if (widget.currentRow.CDTPITEMPROD || widget.currentRow.CDGENPROD) {
    		widget.getField('DSGENPROD').validations.required = true;
    		widget.getField('NMTPITEMPROD').validations.required = true;
    	} else {
    		delete widget.getField('DSGENPROD').validations.required;
    		delete widget.getField('NMTPITEMPROD').validations.required;
    	}
	};
	
	this.removeHintFields = function(widgets) {
		if (!Array.isArray(widgets)){
			widgets = [widgets];
		}

		widgets.forEach(function(widget) {
			delete widget.currentRow.$error;
		});
	};
    
    this.rulesSelectClasfiscal = function(widget) {
    	var clasfiscal = widget.currentRow.CDCLASFISC;
    	var genero = clasfiscal.substr(0, 2);
    	var filter = [{
    		"name": "CDGENPROD",
    		"operator": "=",
    		"value": genero
    	}];
    	General.callRestEngine('cadEst_produto#/crud/generoprod_livromagnetico', 
    							'FilterData', filter).then(function(data) {
    		data = data.dataset.generoprod_livromagnetico;
    		if (data.length > 0) {
    			widget.currentRow.CDGENPROD = data[0].CDGENPROD;
    			widget.currentRow.DSGENPROD = data[0].DSGENPROD;
    		} else {
    			widget.currentRow.CDGENPROD = null;
    			widget.currentRow.DSGENPROD = null;
    		}
    		this.rulesItemGenero(widget);
    	}.bind(this), this.errorRequest);
	};
	
	this.validaFatoConv = function(widget) {
		let fieldFatoConv = widget.container.getWidget('Estoque').getField('VRFATOCONV');
		if (this.isProductStock()) {
			fieldFatoConv.setValue(1);
			widget.currentRow.VRFATOCONV = 1;
		}else{
			if(fieldFatoConv.value() <= 0){
				fieldFatoConv.setValue(null);
				ScreenService.showMessage('Favor de conversão deve ser maior que 0');
			}
		}
	};

	this.rulesToCardapio = function(widget) {
		if (this.isProductStock()) {
			widget.getField('VRARREDREQ').readOnly = false;
		} else {
			widget.getField('VRARREDREQ').readOnly = true;
		}
	};

	this.rulesToCatering = function(widget) {
		if (this.isProductStock()) {
			widget.getField('DSVRYIELD').readOnly = false;
			widget.getField('DSVRYIELD').validations.required = true;
		} else {
			widget.getField('DSVRYIELD').readOnly = true;
			delete widget.getField('DSVRYIELD').validations.required;
		}
	};
	
	this.rulesToEstoque = function(widget) {
		if (this.isProductStock()) {
			widget.getField('VRPESOUNID').readOnly = false;
			widget.getField('DSPEFATOCORR').readOnly = false;
			widget.getField('DSPEFATOCORR').validations.required = true;
			widget.getField('NMPRODESTO').readOnly = true;
			delete widget.getField('NMPRODESTO').validations.required;
			widget.getField('VRFATOCONV').readOnly = true;
			delete widget.getField('VRFATOCONV').validations.required;
		} else {
			widget.getField('VRPESOUNID').readOnly = true;
			widget.getField('DSPEFATOCORR').readOnly = true;
			delete widget.getField('DSPEFATOCORR').validations.required;
			widget.getField('NMPRODESTO').readOnly = false;
			widget.getField('NMPRODESTO').validations.required = true;
			widget.getField('VRFATOCONV').readOnly = false;
			widget.getField('VRFATOCONV').validations.required = true;
		}
	};

    this.rulesToMoveRow = function(mainWidget) {
    	ScreenService.showLoader();
    	mainWidget.widgets[0].activate().then(function() {
			if (mainWidget.currentRow.__is_new) {	
				this.rulesToInsert(mainWidget);
			} else {
				this.getCorrecao(mainWidget);
				this.allWidgetsToView();
				this.updateWidgets(mainWidget.currentRow);
				ScreenService.hideLoader();
				templateManager.container.getWidget('Detalhamento').activate();
				templateManager.container.getWidget('Detalhamento').redraw();
				mainWidget.openTab('produtos2');
/*				mainWidget.widgets[0].activate().then(function() {
					mainWidget.widgets[0].widgets[0].activate().then(function() {
						mainWidget.widgets[0].widgets[0].activate();
						ScreenService.hideLoader();
					});
				});*/
			}
    	}.bind(this));
    	templateManager.container.getWidget('impostos').openFilter = true;
	};

	this.rulesToInsert = function(mainWidget) {
		var widget = mainWidget.widgets[0];
		General.callRestEngine('cadEst#/crud/paramplaneja', 'FilterData', []).then(function(data) {
			data = data.dataset.paramplaneja[0];
			widget.widgets.forEach(function(widgetChild) {
				this.editMode(widgetChild, true);
				widgetChild.currentRow.__is_new = true;
				widgetChild.currentRow.NRCORSAFRA = data? data.NRCORSAFRA : null;
				widgetChild.currentRow.NRCORINICSAF = data? data.NRCORINICSAF : null;
				widgetChild.currentRow.NRCORENTRSAF = data? data.NRCORENTRSAF : null;
				widgetChild.applyDefaultValue();
			}.bind(this));
			widget.activate();
			ScreenService.hideLoader();
		}.bind(this), this.errorRequest);
	};

	this.rulesToProducao = function(widget) {
		if (this.isProductStock()) {
			widget.getField('NMPRODPROD').readOnly = false;
			widget.getField('VRFATOCONVPR').readOnly = false;
			widget.getField('IDPRODPROD').readOnly = false;
		} else {
			widget.getField('NMPRODPROD').readOnly = true;
			widget.getField('VRFATOCONVPR').readOnly = true;
			widget.getField('IDPRODPROD').readOnly = true;
		}
		this.ruleToProdProducao(widget);
	};

	this.ruleToProdProducao = function(widget) {
		if (widget.currentRow.CDPRODPROD) {
			widget.getField('VRFATOCONVPR').validations.required = true;
		} else {
			delete widget.getField('VRFATOCONVPR').validations.required;
		}
	};
	
	this.rulesTreeGroup = function(widget) {
		var currentRow = widget.currentRow;
		var groupField = widget.getField('NMARVOREPROD');

		if (currentRow.NRTPARVPROD) {
			groupField.dataSourceFilter[0].value = currentRow.NRTPARVPROD;
			groupField.readOnly = false;
			groupField.reload();
		} else {
			groupField.readOnly = true;
		}

	};

    this.save = function(widget) {
    	this.validaFatoConv(widget);
    	this.setCorrecao(widget);
		if (widget.currentRow.__is_new) {
			this.saveNew(widget);
		} else if (widget.isValid()) {
			this.callSave(widget, 'cadEst_produto#/saveProduct');
		}
	};
	
	this.saveNew = function(widget) {
		var save = true;
		var widgets = widget.getParent().widgets;
		
		for (var index = 0; index < widgets.length; index++) {
			var widgetChild = widgets[index];
			var activateWidget = function(){
				this.activate();
			};
			
			if (!widgetChild.isValid()) {
				widgetChild.activate().then(activateWidget.bind(widgetChild));
				save = false;
				index = widgets.length;
			}
		}

		if (save) {
			this.callSave(widget, 'cadEst_produto#/saveProduct');
		}
		
	};

	this.saveFiscal = function(widget) {
		if (widget.currentRow.__is_new) {
			this.save(widget);
		} else if (widget.isValid()) {
			this.callSave(widget, 'cadEst_produto#/saveAbaFiscal');
		}
	};

	this.saveProdutoArvoreProduto = function(widget) {
		if (widget.isValid()) {
			var row = widget.currentRow;
			General.callRestEngine('cadEst_produto#/arvoreprodtree/save', 'Row', row).then(function (success) {
				widget.view();
				ScreenService.closeSwipe();
				widget.getField('NMARVOREPROD').readOnly = true;
			}, this.errorRequest);
		}
	};

	this.getCorrecao = function(widget) {
		var currentRow = widget.currentRow;
		if (currentRow.VRPEFATOCORR != null) {
			var vrpefatocorr = parseFloat(currentRow.VRPEFATOCORR);
			var dspefatocorr = 1 + (vrpefatocorr / 100);
			var dsvryield = 100 - vrpefatocorr;
			widget.currentRow.DSPEFATOCORR = dspefatocorr;
			widget.currentRow.DSVRYIELD = dsvryield;
		}
	};
	
	this.setCorrecao = function(widget) {
		var currentRow = widget.currentRow;

		if (currentRow.DSPEFATOCORR != null) { 
			currentRow.DSPEFATOCORR = String(currentRow.DSPEFATOCORR).replace(',','.'); 
			var dspefatocorr = parseFloat(currentRow.DSPEFATOCORR);
			if(dspefatocorr >= 1 && dspefatocorr < 2){
				dspefatocorr = (dspefatocorr-1) * 100;
				var dsvryield = 100 - dspefatocorr;
				currentRow.VRPEFATOCORR = dspefatocorr;
				widget.currentRow.DSVRYIELD = dsvryield;
			}else{
				if(currentRow.CDPRODESTO == currentRow.CDPRODUTO)
					ScreenService.showMessage('Fator de correção deve estar entre 1,00 e 1,99.');
				currentRow.DSPEFATOCORR = null;
			}
		}
	};

	this.setVrpefatocorr = function (currentRow) {
		var dsvryield = parseInt(currentRow.DSVRYIELD);
		if (dsvryield >= 1 && dsvryield <= 100) {
			currentRow.DSPEFATOCORR = 1 + ((100 - dsvryield) / 100);
			currentRow.VRPEFATOCORR = 100 - dsvryield;
		} else {
			currentRow.DSVRYIELD = null;
			currentRow.VRPEFATOCORR = null;
			currentRow.DSPEFATOCORR = null;
			ScreenService.showMessage('O YIELD deve ser de 1 até 100');
		}
	};
	
	this.setVrYield = function(currentRow) {
		var dspefatocorr = currentRow.DSPEFATOCORR; 
		if (dspefatocorr < 2 && dspefatocorr > 0.99) {
			currentRow.DSVRYIELD = (2 - dspefatocorr) * 100;
			dspefatocorr = parseInt((dspefatocorr - 1) * 100);
			currentRow.VRPEFATOCORR = dspefatocorr;
		} else { 
			currentRow.DSVRYIELD = null;
			currentRow.VRPEFATOCORR = null;
			currentRow.DSPEFATOCORR = null;
			ScreenService.showMessage('O Fator de Correção deve ser de 1,0 até 1,99');
		}
	};

	this.sugestedArvprod = function(widget) {
		var prodnivante = widget.currentRow.CDARVPRODNIVANTE;
		var nvprodnivante = widget.currentRow.CDNVPRODNIVANTE;
		var rigthLevel = (General.getLevelByMask('GER_CDPICTPROD', 1).length - 1);
		if (nvprodnivante && nvprodnivante != rigthLevel) {
			ScreenService.showMessage('Produto selecionado inválido. Só é permitido selecionar produtos de nível ' + rigthLevel + '.');
			
			/* MSG NOVA */
			var variaveis = {
                NIVELCOMPLETO: rigthLevel
            };
			
			MessageService.showMessageByCode("NIVELMAXPROD", variaveis, {"type":"error"});
			/* FIM MSG NOVA */
			
			widget.currentRow.CDPRODNIVANTE = null;
			widget.currentRow.CDARVPRODNIVANTE = null;
			widget.currentRow.CDNVPRODNIVANTE = null;
		} else if (nvprodnivante) {
			var row = {
				'PARENTCDPRODUTO': prodnivante,
				'PARENTNVPRODUTO': nvprodnivante
			};
			if (!widget.currentRow.CDARVPROD) {
				General.callRestEngine('cadEst_produto#/sugestedArvprod', 'Row', row).then(function(request) {
					var sugested = request.dataset.sugestedArvprod[0];
					widget.currentRow.CDARVPROD = sugested.CDDARVPROD;
				}.bind(this), this.errorRequest);
			}
		}
	};
	
	this.updateProductInMainWidget = function() {
		templateManager.container.getWidget('produtos').reload();
	};

	this.updateWidgets = function(valueToUpdate) {
		var widget = templateManager.container.getWidget('produtos2');
		valueToUpdate = Util.clone(valueToUpdate, ignoredKeys);
		widget.widgets.forEach(function(widget) {
		    widget.currentRow = valueToUpdate;
		});
	};
	
	this.updateWidgetsIfAdding = function(widget) {
		if (widget.currentRow.__is_new) {
			this.updateWidgets(widget.currentRow);
		}
	};

	this.validateTpTree = function(widget) {
		var row  = widget.currentRow;
		if (!row.NRARVOREPRODPAI) {
			delete row.NMTPARVORE;
			delete row.NRARVOREPROD;
			delete row.NRTPARVPROD;		
			delete row.NMARVOREPROD;
			ScreenService.showMessage('Não é possível escolher o primeiro nível do Agrupamento de Produto.');
		}
	};
	
	this.deleteProduct = function(widget){
    	var row = Util.clone(widget.currentRow, ignoredKeys);
		row.DEBUGMODE = false;
		General.callRestEngine('cadEst#/deleteProduct', 'Row', row).then(result =>{
			if(isset(() => result.messages)){
				ScreenService.showMessage(result.messages[0].message);
			}else{
				widget.getParent().getParent().reload();
				ScreenService.closeSwipe();
			}
		});
    };
	
	this.newProduto = function(widget){
		var detalhamento = widget.container.getWidget('Detalhamento');
		var codArvore = detalhamento.getField('CDARVPRODNIVANTE');
			widget.newRow();
			codArvore.dataSource.load();
	};
	
	this.LoadCodArvore = function(widget){
		if(widget.currentRow.__is_new){
			var nivelProd = widget.getField('CDARVPRODNIVANTE');
			nivelProd.dataSource.load();
			var data = nivelProd.dataSource.data;
			
			if(data.length === 0)
				delete nivelProd.validations.required;
			else
				nivelProd.validations.required = true;
		}
	};
	

	this.validaFator = function (widget) {
		var currentRow = widget.currentRow;
		if (currentRow.VRFATOCONV <= 0) {
			ScreenService.showMessage('Fator de Conversão deve ser maior que 0.');
			currentRow.VRFATOCONV = "";
		}
	};
	
	this.validateProductPermissions = function (widget){
		var cdnvarvore = widget.currentRow.CDARVPRODNIVANTE;
		var fieldTpProduto = widget.getField('IDESTOCOMP');
		var filter = [
                {
                    "name": "P_CDPRODUTO",
                    "operator": "=",
                    "value": cdnvarvore
                },
                {
                	"name": "CDOPERADOR",
                    "operator": "=",
                    "value": "OPERADOR_LOGADO"
                }
		    ];
		General.callRestEngine('cadEst#/crud/gropernvprod_operador', 'FilterData', filter).then(response => {
			if(response.dataset.gropernvprod_operador[0]){
				let resultRow = response.dataset.gropernvprod_operador[0];
				if(resultRow.IDPERMINCPRODEST == 'S')
					fieldTpProduto.readOnly = false;
				else{
					fieldTpProduto.readOnly = true;
					widget.currentRow.IDESTOCOMP = 'C';
				}
			}else{
				fieldTpProduto.readOnly = false;
			}
				
		});
		
	};
	
	this.setStockProductFilter = function(args){
		let field = args.owner.field;
		let valueToFilter = General.getFieldValue('CDARVPRODNIVANTE', 'Detalhamento');
		valueToFilter = valueToFilter? valueToFilter+'%' : '%%';
		
		field.dataSourceFilter[0].value = valueToFilter;
		
	};
	
	this.openPopupCodBar = function (){
		let widPopupCod = templateManager.container.getWidget('popUpCodigoBarra');
		let widgetProduto = templateManager.container.getWidget('produtos');
		let nomeProd = widgetProduto.currentRow.NMPRODUTO;
		widPopupCod.label = 'Codigos de Barra - '+nomeProd;
		ScreenService.openPopup(widPopupCod);
	};
	
	this.saveCodeBars = function(args){
		let rows = args.dataSource;
		let parent = args.owner.getParent().getWidget('produtos');
		let codprod = parent.currentRow.CDPRODUTO;
		rows.forEach(row => {
			if(row.__is_new){
				row.CDPRODUTO = codprod;
				delete row.__leftActions;
				delete row.__rightActions;
			}
		});
		let edited = rows.some( row => {return row.changed && !row.__is_new;});
		if(edited)
			ScreenService.showMessage('Para alterar o registro deve ser excluído e adicionado novamente.');
		let rowsToSave = rows.filter(row =>{
			return row.__is_new;
		});
		return saveDataset('cadEst#/crud/cdbarraprod/save', rowsToSave).then((success)=>{
			args.owner.reload();
			args.owner.cancelActionClick();
		}, (error)=>{
			ScreenService.showMessage(error.data.error);
			args.owner.cancelActionClick();
		});
	};
	
	var saveDataset = function(dataSourceName, dataToSave, otherParams = {}) {
        return restEngine.post(dataSourceName, Util.extend({
            "requestType": "DataSet",
            "dataset": dataToSave
        }, otherParams || {}), undefined, undefined, undefined, undefined, 8001000);
    };
    
    this.newCodeBar = function(widget){
    	General.widgetNewRow(widget);
    };
    
    this.deleteCodeBar = function(args){
    	let widget = args.owner.widget;
    	General.deleteCrud(widget).then(()=>widget.reload());
    };
    
    var isset = (accessor) => {
	  try {
	    // Note we're seeing if the returned value of our function is not
	    // undefined
	    return typeof accessor() !== 'undefined' && accessor() !== null;
	  } catch (e) {
	    // And we're able to catch the Error it would normally throw for
	    // referencing a property of undefined
	    return false;
	  }
	};
    
};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01900_cadastroproduto_controller', ger01900_cadastroproduto_controller);
});